;******************************************************************************/
;*                                                                            */
;*  Cedocida DV-Codec                                                         */
;*                                                                            */
;*  Copyright (C) 2005 Andreas Dittrich <dittrich@eit.uni-kl.de>              */
;*  Project start: 15.12.2003                                                 */
;*  Last change  : 08.05.2005                                                 */
;*                                                                            */
;******************************************************************************/
;*                                                                            */
;*  This program is free software; you can redistribute it and/or modify      */
;*  it under the terms of the GNU General Public License as published by      */
;*  the Free Software Foundation; either version 2 of the License, or         */
;*  (at your option) any later version.                                       */
;*                                                                            */
;*  This program is distributed in the hope that it will be useful,           */
;*  but WITHOUT ANY WARRANTY; without even the implied warranty of            */
;*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
;*  GNU General Public License for more details.                              */
;*                                                                            */
;*  You should have received a copy of the GNU General Public License         */
;*  along with this program; if not, write to the Free Software               */
;*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
;*                                                                            */
;******************************************************************************/

%include "nasm.inc"


;=============================================================================
; Read only data
;=============================================================================

SECTION .rodata data align=16

rgb_mask:
dd 0x00ffffff, 0x00ffffff

rb_mask:
dd 0x0000ffff, 0x0000ffff

chroma_mask:
dd 0xff00ff00, 0

low32_mask:
dd 0xffffffff, 0

fpix_add:
dd 0x00808000, 0x00808000


add_32__219_224:
dd 32, 0

fraction__219_224:
dd 0x00084000, 0;		// ( 16 + 1/2 )<<15

y1y2_mult__219_224:
dd 19077, 0;			// { (1<<14)*(255/219), 0 }

fpix_mul__219_224:
dd 507, 642;				// { (224/255)/(1-0.114)*512, (224/255)/(1-0.299)*512 }

cybgr_64__219_224:
dw 3208, 16519, 8414, 0;	// { 0.114*(219/255)*(1<<15), 0.587*..., 0.299*... }


add_32__255_255:
dd 0, 0

fraction__255_255:
dd 0x00004000, 0;		// (  0 + 1/2 )<<15

y1y2_mult__255_255:
dd 16384, 0;			// { (1<<14), 0 }

fpix_mul__255_255:
dd 578, 730;				// { 1/(1-0.114)*512, 1/(1-0.299)*512 }

cybgr_64__255_255:
dw 3735, 19235, 9798, 0;	// { 0.114*(1<<15), 0.587*..., 0.299*... }


add_32:
dd 32, 0 
fraction:
dd 0x00084000, 0 
y1y2_mult:
dd 19077, 0
fpix_mul:
dd 506, 642 
cybgr_64:
dw 3208, 16519, 8414, 0



;=============================================================================
; Code
;=============================================================================

SECTION .text

;-----------------------------------------------------------------------------
; extern "C" void mmx_ConvertRGB32toYUY2_ad(
;	unsigned int *src, 
;	unsigned int *dst, 
;	int src_pitch, 
;	int dst_pitch, 
;	int w, 
;	int h, 
;	int color_range );
;-----------------------------------------------------------------------------

cglobal mmx_ConvertRGB32toYUY2_ad
mmx_ConvertRGB32toYUY2_ad:
		INIT_SHADOWSTACK
		push rbx
		push rdi
		push rsi
		%define NPUSH 3

		test dword [rsp + (7 + NPUSH)*NPTR], 1
		jz .color_range__RecBT601_rgb32

	.color_range__RecBT601_full_rgb32:
		movq mm0, [y1y2_mult__255_255]
		movq mm1, [fpix_mul__255_255]
		movq mm2, [cybgr_64__255_255]
		movq mm3, [fraction__255_255]
		movq mm4, [add_32__255_255]
		jmp .set_constants_rgb32

	.color_range__RecBT601_rgb32:
		movq mm0, [y1y2_mult__219_224]
		movq mm1, [fpix_mul__219_224]
		movq mm2, [cybgr_64__219_224]
		movq mm3, [fraction__219_224]
		movq mm4, [add_32__219_224]

	.set_constants_rgb32:
		movq [y1y2_mult], mm0
		movq [fpix_mul], mm1
		movq [cybgr_64], mm2
		movq [fraction], mm3
		movq [add_32], mm4

%define SRC rax
%define DST rdi
%define RGBOFFSET rcx
%define YUVOFFSET rdx

		mov DST, [rsp + (2 + NPUSH)*NPTR]		; dst
		movsxd rax, DWORD [rsp + (5 + NPUSH)*NPTR]		; w
		sal rax, 2								; w<<2
		mov rbx, rax					
		movsxd rax, DWORD [rsp + (4 + NPUSH)*NPTR]
		sal rax, 2
		mov [rsp + (4 + NPUSH)*NPTR], rax			; dst_pitch*4
		movsxd rax, DWORD [rsp + (3 + NPUSH)*NPTR]
		sal rax, 2
		mov [rsp + (3 + NPUSH)*NPTR], rax			; src_pitch*4
		mov rcx, rax		; src_pitch*4
		movsxd rax, DWORD [rsp + (6 + NPUSH)*NPTR]		; h
		dec rax									; h-1
		imul rax, rcx							; src_pitch*4*(h-1)
		add rax, [rsp + (1 + NPUSH)*NPTR]		; src + src_pitch*(h-1)*4
		movsxd rsi, DWORD [rsp + (6 + NPUSH)*NPTR]		; h

	.row_loop_rgb32:
		mov RGBOFFSET,0
		mov YUVOFFSET,0
		cmp RGBOFFSET, rbx
		jge NEAR .outloop_rgb32		; Jump out of loop if true (width==0?? - somebody brave should remove this test)
		movq mm0, [SRC+RGBOFFSET]		; mm0= XXR2 G2B2 XXR1 G1B1
		punpcklbw mm1,mm0						; mm1= 0000 R100 G100 B100
		movq mm4,[cybgr_64]
	
		align 16
	.re_enter_rgb32:
		punpckhbw mm2,mm0				; mm2= 0000 R200 G200 B200
		movq mm3,[fraction]
		psrlw mm1,8							; mm1= 0000 00R1 00G1 00B1
		psrlw mm2,8							; mm2= 0000 00R2 00G2 00B2 
		movq mm6,mm1						; mm6= 0000 00R1 00G1 00B1 (shifter unit stall)
		pmaddwd mm1,mm4						; mm1= v2v2 v2v2 v1v1 v1v1   y1 //(cyb*rgb[0] + cyg*rgb[1] + cyr*rgb[2] + 0x108000)
		movq mm7,mm2						; mm7= 0000 00R2 00G2 00B2		 
		movq mm0, [rb_mask]
		pmaddwd mm2,mm4						; mm1= w2w2 w2w2 w1w1 w1w1   y2 //(cyb*rgbnext[0] + cyg*rgbnext[1] + cyr*rgbnext[2] + 0x108000)
		paddd mm1,mm3						; Add rounding fraction
		paddw mm6,mm6					;do not average, because of bluring 
		paddd mm2,mm3						; Add rounding fraction (lower dword only)
		movq mm4,mm1
		movq mm5,mm2
		pand mm1, [low32_mask]
		psrlq mm4,32
		pand mm6,mm0						; Clear out accumulated G-value mm6= 0000 RRRR 0000 BBBB
		pand mm2, [low32_mask]
		psrlq mm5,32
		paddd mm1,mm4				    ;mm1 Contains final y1 value (shifted 15 up)
		psllq mm6, 14					; Shift up accumulated R and B values (<<15 in C)
		paddd mm2,mm5					  ;mm2 Contains final y2 value (shifted 15 up)
		psrlq mm1,15
		movq mm3,mm1
		psrlq mm2,15
		movq mm4,[add_32]
		paddd mm3,mm3
		movq mm5,[y1y2_mult]
		psubd mm3,mm4					; mm3 = y1+y2-32 		mm0,mm4,mm5,mm7 free
		movq mm0,[fpix_add]			; Constant that should be added to final UV pixel
		pmaddwd mm3,mm5				; mm3=scaled_y (latency 2 cycles)
		movq mm4,[fpix_mul]		; Constant that should be multiplied to final UV pixel	  
		psllq mm2,16					; mm2 Y2 shifted up (to clear fraction) mm2 ready
		punpckldq mm3,mm3						; Move scaled_y to upper dword mm3=SCAL ED_Y SCAL ED_Y 
		psubd mm6,mm3								; mm6 = b_y and r_y (stall)
		psrld mm6,9									; Shift down b_y and r_y (>>10 in C-code) 
		por mm1,mm2								; mm1 = 0000 0000 00Y2 00Y1
		pmaddwd mm6,mm4							; Mult b_y and r_y 
		pxor mm2,mm2
		movq mm7,[chroma_mask]
		paddd mm6, mm0							; Add 0x800000 to r_y and b_y 
		add RGBOFFSET, BYTE 8
		psrld mm6, 9									; Move down, so fraction is only 7 bits
		cmp RGBOFFSET, rbx
		jge .outloop_rgb32						; Jump out of loop if true
		packssdw mm6,mm2						; mm6 = 0000 0000 VVVV UUUU (7 bits fraction) (values above 0xff are saturated)
		psllq mm6,1									; Move up, so fraction is 8 bit
		movq mm0,[SRC+RGBOFFSET]		; mm0= XXR2 G2B2 XXR1 G1B1	[From top (to get better pairing)]
		pand mm6,mm7					; Clear out fractions
		por mm6,mm1									; Or luma and chroma together			
		movq mm4, [cybgr_64]        ;                           [From top (to get better pairing)]
		movd [DST+YUVOFFSET], mm6		; Store final pixel						
		punpcklbw mm1,mm0					; mm1= 0000 R100 G100 B100
		add YUVOFFSET, BYTE 4			; Two pixels (packed)
		jmp .re_enter_rgb32
		
	.outloop_rgb32:
		; Do store without loading next pixel
		packssdw mm6,mm2			; mm6 = 0000 0000 VVVV UUUU (7 bits fraction) (values above 0xff are saturated)
		psllq mm6,1						; Move up, so fraction is 8 bit
		pand mm6,mm7					; Clear out fractions
		por mm1,mm6						; Or luma and chroma together
		movd [DST+YUVOFFSET],mm1	; Store final pixel
		
		sub SRC, [rsp + (3 + NPUSH)*NPTR]		; src = src - src_pitch
		add DST, [rsp + (4 + NPUSH)*NPTR]		; dst = dst + dst_pitch

		dec rsi
		jne .row_loop_rgb32

%undef SRC
%undef DST
%undef RGBOFFSET
%undef YUVOFFSET

		pop rsi;
		pop rdi;
		pop rbx;
		ret


;-----------------------------------------------------------------------------
; extern "C" void mmx_ConvertRGB24toYUY2_ad(
;	unsigned int *src, 
;	unsigned int *dst, 
;	int src_pitch, 
;	int dst_pitch, 
;	int w, 
;	int h, 
;	int color_range );
;-----------------------------------------------------------------------------

cglobal mmx_ConvertRGB24toYUY2_ad
mmx_ConvertRGB24toYUY2_ad: 
		INIT_SHADOWSTACK
		push rbx
		push rdi
		push rsi
		%define NPUSH 3

		test dword [rsp + (7 + NPUSH)*NPTR], 1
		jz .color_range__RecBT601_rgb24

	.color_range__RecBT601_full_rgb24:
		movq mm0, [y1y2_mult__255_255]
		movq mm1, [fpix_mul__255_255]
		movq mm2, [cybgr_64__255_255]
		movq mm3, [fraction__255_255]
		movq mm4, [add_32__255_255]
		jmp .set_constants_rgb24

	.color_range__RecBT601_rgb24:
		movq mm0, [y1y2_mult__219_224]
		movq mm1, [fpix_mul__219_224]
		movq mm2, [cybgr_64__219_224]
		movq mm3, [fraction__219_224]
		movq mm4, [add_32__219_224]

	.set_constants_rgb24:
		movq [y1y2_mult], mm0
		movq [fpix_mul], mm1
		movq [cybgr_64], mm2
		movq [fraction], mm3
		movq [add_32], mm4

%define SRC rax
%define DST rdi
%define RGBOFFSET rcx
%define YUVOFFSET rdx

		mov DST, [rsp + (2 + NPUSH)*NPTR]		; dst
		movsxd rax, DWORD [rsp + (5 + NPUSH)*NPTR]		; w
		imul rax, 3								; w*3
		mov rbx, rax					; 	
		movsxd rax, DWORD [rsp + (4 + NPUSH)*NPTR]
		sal rax, 2			; dst_pitch*4
		mov [rsp + (4 + NPUSH)*NPTR], rax
		movsxd rax, DWORD [rsp + (3 + NPUSH)*NPTR]
		sal rax, 2			; src_pitch*4
		mov [rsp + (3 + NPUSH)*NPTR], rax
		mov rcx, rax		; src_pitch*4
		movsxd rax, DWORD [rsp + (6 + NPUSH)*NPTR]		; h
		dec rax									; h-1
		imul rax, rcx							; src_pitch*4*(h-1)
		add rax, [rsp + (1 + NPUSH)*NPTR]		; src + src_pitch*(h-1)*4
		movsxd rsi, DWORD [rsp + (6 + NPUSH)*NPTR]		; h

	.row_loop_rgb24:
		mov RGBOFFSET,0
		mov YUVOFFSET,0
		cmp RGBOFFSET, rbx
		jge .outloop_rgb24		; Jump out of loop if true (width==0)
		movq mm0, [SRC+RGBOFFSET]		; mm0= XXXX R2G2 B2R1 G1B1
		punpcklbw mm1,mm0						; mm1= B200 R100 G100 B100
		movq mm4, [cybgr_64]
		psrlq mm0, 24           ;Compensate for RGB24
		align 16

	.re_enter_rgb24:
		punpcklbw mm2,mm0				; mm2= 0000 R200 G200 B200  // high changed to low for RGB24
		psrlw mm1,8							; mm1= 0000 00R1 00G1 00B1
		movq mm3, [fraction]
		psrlw mm2,8							; mm2= 0000 00R2 00G2 00B2 
		movq mm6,mm1						; mm6= 0000 00R1 00G1 00B1 (shifter unit stall)
		pmaddwd mm1,mm4						; mm1= v2v2 v2v2 v1v1 v1v1   y1 //(cyb*rgb[0] + cyg*rgb[1] + cyr*rgb[2] + 0x108000)
		movq mm7,mm2						; mm7= 0000 00R2 00G2 00B2		 
		movq mm0, [rb_mask]
		pmaddwd mm2,mm4						; mm1= w2w2 w2w2 w1w1 w1w1   y2 //(cyb*rgbnext[0] + cyg*rgbnext[1] + cyr*rgbnext[2] + 0x108000)
		paddd mm1,mm3						; Add rounding fraction
		paddw mm6,mm6
		paddd mm2,mm3						; Add rounding fraction (lower dword only)
		movq mm4,mm1
		movq mm5,mm2
		pand mm1, [low32_mask]
		psrlq mm4,32
		pand mm6,mm0						; Clear out accumulated G-value mm6= 0000 RRRR 0000 BBBB
		pand mm2, [low32_mask]
		psrlq mm5,32
		paddd mm1,mm4				    ;mm1 Contains final y1 value (shifted 15 up)
		psllq mm6, 14					; Shift up accumulated R and B values (<<15 in C)
		paddd mm2,mm5					  ;mm2 Contains final y2 value (shifted 15 up)
		psrlq mm1,15
		movq mm3,mm1
		psrlq mm2,15
		movq mm4,[add_32]
		paddd mm3,mm3
		movq mm5,[y1y2_mult]
		psubd mm3,mm4					; mm3 = y1+y2-32 		mm0,mm4,mm5,mm7 free
		movq mm0,[fpix_add]			; Constant that should be added to final UV pixel
		pmaddwd mm3,mm5				; mm3=scaled_y (latency 2 cycles)
		movq mm4,[fpix_mul]		; Constant that should be multiplied to final UV pixel	  
		psllq mm2,16					; mm2 Y2 shifted up (to clear fraction) mm2 ready
		punpckldq mm3,mm3						; Move scaled_y to upper dword mm3=SCAL ED_Y SCAL ED_Y 
		psubd mm6,mm3								; mm6 = b_y and r_y (stall)
		psrld mm6,9									; Shift down b_y and r_y (>>10 in C-code) 
		por mm1,mm2								; mm1 = 0000 0000 00Y2 00Y1
		pmaddwd mm6,mm4							; Mult b_y and r_y 
		pxor mm2,mm2
		movq mm7,[chroma_mask]
		paddd mm6, mm0							; Add 0x800000 to r_y and b_y 
		add RGBOFFSET, BYTE 6            ; Only change for RGB24!
		psrld mm6,9									; Move down, so fraction is only 7 bits
		cmp RGBOFFSET, rbx
		jge .outloop_rgb24						; Jump out of loop if true
		packssdw mm6,mm2						; mm6 = 0000 0000 VVVV UUUU (7 bits fraction) (values above 0xff are saturated)
		psllq mm6,1									; Move up, so fraction is 8 bit
		movq mm0, [SRC+RGBOFFSET]		; mm0= XXR2 G2B2 XXR1 G1B1	[From top (to get better pairing)]
		pand mm6,mm7					; Clear out fractions
		por mm6,mm1									; Or luma and chroma together			
		movq mm4, [cybgr_64]        ;                           [From top (to get better pairing)]
		movd [DST+YUVOFFSET], mm6		; Store final pixel
		punpcklbw mm1,mm0					; mm1= 0000 R100 G100 B100
		add YUVOFFSET, BYTE 4 			; Two pixels (packed)
		psrlq mm0, 24           ; Compensate for RGB24
		jmp .re_enter_rgb24

	.outloop_rgb24:
		; Do store without loading next pixel
		packssdw mm6,mm2			; mm6 = 0000 0000 VVVV UUUU (7 bits fraction) (values above 0xff are saturated)
		psllq mm6,1						; Move up, so fraction is 8 bit
		pand mm6,mm7					; Clear out fractions
		por mm1,mm6						; Or luma and chroma together
		movd [DST+YUVOFFSET],mm1	; Store final pixel

		sub SRC, [rsp + (3 + NPUSH)*NPTR]		; src = src - src_pitch
		add DST, [rsp + (4 + NPUSH)*NPTR]		; dst = dst + dst_pitch

		dec rsi
		jne .row_loop_rgb24

%undef SRC
%undef DST
%undef RGBOFFSET
%undef YUVOFFSET

		pop rsi;
		pop rdi;
		pop rbx;
		ret








